<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { CtfCta } from '../../models';
import { kebabCase } from 'lodash';
import { ContentfulComponentMixin } from '~/mixins';

export default Vue.extend({
  name: 'ContentfulCta',
  mixins: [ContentfulComponentMixin],
  props: {
    data: {
      type: Object as PropType<CtfCta>,
      required: true,
      default: null,
    },
  },
  methods: {
    kebabCase,
  },
});
</script>

<template>
  <SlpRow :id="headerId" class="slp-flex slp-flex-column">
    <SlpColumn :cols="12">
      <section class="container">
        <SlpTypography
          v-if="data.header"
          tag="h2"
          variant="heading2-bold"
          class="container__title"
        >
          <span class="container__title-image"></span>{{ data.header }}
        </SlpTypography>

        <SlpTypography
          v-if="data.subheader"
          tag="h3"
          variant="heading4"
          class="container__subtitle"
        >
          {{ data.subheader }}
        </SlpTypography>
        <SlpTypography
          v-if="data.description"
          class="container__text"
          tag="p"
          variant="heading5"
        >
          {{ data.description }}
        </SlpTypography>
        <div class="container__cta">
          <SlpButton
            v-if="data.buttonText"
            class="slp-mr-8 cta__button"
            :href="data.buttonUrl"
            :data-ga-name="data.buttonText"
            data-ga-location="body"
            >{{ data.buttonText }}</SlpButton
          >
        </div>
      </section>
    </SlpColumn>
  </SlpRow>
</template>

<style lang="scss" scoped>
.cta__button {
  justify-content: center;
}
.container {
  margin: $spacing-64 0;
  background: $color-surface-800;
  border-radius: $border-radius-24;
  padding: $spacing-48;
  &__title {
    margin-bottom: $spacing-32;
    &-image {
      position: relative;
      display: inline;
    }
  }

  &__subtitle {
    margin-bottom: $spacing-16;
    font-weight: 600;
  }

  &__text {
    margin-bottom: $spacing-24;
    font-size: 16px;
    line-height: 28px;
  }

  @media (max-width: $breakpoint-sm) {
    &__cta:deep a {
      width: 100%;

      &:nth-of-type(2) {
        margin-top: $spacing-8;
      }
    }

    &__title {
      font-size: 24px;
      line-height: 30px;
    }

    &__subtitle {
      font-weight: normal;
      font-size: 19px;
      line-height: 24px;
    }
  }
}
</style>
